// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/bigquery/biglake/v1/metastore.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BIGQUERY_BIGLAKE_V1_MOCKS_MOCK_METASTORE_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BIGQUERY_BIGLAKE_V1_MOCKS_MOCK_METASTORE_CONNECTION_H

#include "google/cloud/bigquery/biglake/v1/metastore_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace bigquery_biglake_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `MetastoreServiceConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `MetastoreServiceClient`. To do so,
 * construct an object of type `MetastoreServiceClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockMetastoreServiceConnection
    : public bigquery_biglake_v1::MetastoreServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(StatusOr<google::cloud::bigquery::biglake::v1::Catalog>,
              CreateCatalog,
              (google::cloud::bigquery::biglake::v1::CreateCatalogRequest const&
                   request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::bigquery::biglake::v1::Catalog>,
              DeleteCatalog,
              (google::cloud::bigquery::biglake::v1::DeleteCatalogRequest const&
                   request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::bigquery::biglake::v1::Catalog>, GetCatalog,
      (google::cloud::bigquery::biglake::v1::GetCatalogRequest const& request),
      (override));

  MOCK_METHOD(
      StreamRange<google::cloud::bigquery::biglake::v1::Catalog>, ListCatalogs,
      (google::cloud::bigquery::biglake::v1::ListCatalogsRequest request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::bigquery::biglake::v1::Database>, CreateDatabase,
      (google::cloud::bigquery::biglake::v1::CreateDatabaseRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::bigquery::biglake::v1::Database>, DeleteDatabase,
      (google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::bigquery::biglake::v1::Database>, UpdateDatabase,
      (google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::bigquery::biglake::v1::Database>, GetDatabase,
      (google::cloud::bigquery::biglake::v1::GetDatabaseRequest const& request),
      (override));

  MOCK_METHOD(
      StreamRange<google::cloud::bigquery::biglake::v1::Database>,
      ListDatabases,
      (google::cloud::bigquery::biglake::v1::ListDatabasesRequest request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::bigquery::biglake::v1::Table>, CreateTable,
      (google::cloud::bigquery::biglake::v1::CreateTableRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::bigquery::biglake::v1::Table>, DeleteTable,
      (google::cloud::bigquery::biglake::v1::DeleteTableRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::bigquery::biglake::v1::Table>, UpdateTable,
      (google::cloud::bigquery::biglake::v1::UpdateTableRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::bigquery::biglake::v1::Table>, RenameTable,
      (google::cloud::bigquery::biglake::v1::RenameTableRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::bigquery::biglake::v1::Table>, GetTable,
      (google::cloud::bigquery::biglake::v1::GetTableRequest const& request),
      (override));

  MOCK_METHOD(StreamRange<google::cloud::bigquery::biglake::v1::Table>,
              ListTables,
              (google::cloud::bigquery::biglake::v1::ListTablesRequest request),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace bigquery_biglake_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BIGQUERY_BIGLAKE_V1_MOCKS_MOCK_METASTORE_CONNECTION_H
